#ifndef BKAPI_H
#define BKAPI_H

/* BlizKick EXTRES buffer api - bkapi header file

   Written by Harry "Piru" Sintonen, Jan 2000, Jun 2002.
   Public Domain.
*/


#include <exec/types.h>
#include <exec/memory.h>
#include <exec/semaphores.h>
#include <exec/resident.h>

#include "myregargs.h"

#define BKA_MemoryInsane 0x0042000C  /* Sanity check on memory header failed */

typedef enum
{
  ERH_API_V1 = 1,
  ERH_API_V2
} ERHVER;

struct bkerhss
{
  struct SignalSemaphore	bkerh_ss;
  ULONG			bkerh_version;	/* currently ERH_API_V1 */
  UWORD			bkerh_flags;	/* flags, see below */
  struct MemHeader *		bkerh_mh;	/* pointer to MemHeader of EXTRES buffer */

  /* These two are available if BKERHB_MMUPAGEALIGNED is set
  */
  APTR			bkerh_mmustart;	/* MMU pagesize aligned ERB start */
  ULONG			bkerh_mmulen;	/* MMU pagesize aligned ERB len */
  /* future fields here...
  */
};

/* bkerh_flags
*/
#define BKERHB_MMUPAGEALIGNED	0	/* have bkerh_mmustart and bkerh_mmulen fields */

#define BKERHF_MMUPAGEALIGNED	(1 << BKERHB_MMUPAGEALIGNED)

APTR MASM er_createhandle(void);
void MASM er_deletehandle(MREG(a0, APTR));
ULONG MASM er_gethandleapiver(MREG(a0, APTR handle));
void * MASM er_alloc(MREG(a0, APTR), MREG(d0, ULONG));
void * MASM er_allocmem(MREG(a0, APTR), MREG(d0, ULONG), MREG(d1, ULONG));
void MASM er_free(MREG(a0, APTR), MREG(a1, void *), MREG(d0, ULONG));
void * MASM er_allocvec(MREG(a0, APTR), MREG(d0, ULONG), MREG(d1, ULONG));
void MASM er_freevec(MREG(a0, APTR), MREG(a1, void *));
APTR MASM er_lock(MREG(a0, APTR));
void MASM er_unlock(MREG(a0, APTR), MREG(a1, APTR));
ULONG MASM er_getarea(MREG(a0, APTR), MREG(a1, ULONG *));
ULONG MASM er_getmmuarea(MREG(a0, APTR), MREG(a1, ULONG *));
ULONG MASM er_availmem(MREG(a0, APTR), MREG(d1, ULONG));
struct Resident * MASM er_nextresident(MREG(a0, APTR), MREG(a1, struct Resident *));
struct Resident * MASM er_findresident(MREG(a0, APTR), MREG(a1, STRPTR));
LONG MASM er_getwriteprotect(MREG(a0, APTR));
LONG MASM er_setwriteprotect(MREG(a0, APTR), MREG(d0, LONG onoff));

#endif /* BKAPI_H */
